#include "ahp.hpp"
#include "crt.hpp"

static struct PluginStartupInfo Info;

int WINAPI _export Start(const struct PluginStartupInfo *FarInfo,const struct AHPluginStartupInfo *AHInfo)
{
  (void *)AHInfo;
  Info=*FarInfo;
  return 0;
}

void WINAPI _export Exit(void)
{
}

int WINAPI _export Message(unsigned long Msg,void *InData,void *OutData)
{
  switch(Msg)
  {
    case AHMSG_GETINFO:
      {
        GetInfoOutData *data=(GetInfoOutData *)OutData;
        data->TypesNumber=1;
        static struct TypeInfo TypesInfo[1];
        memset(TypesInfo,0,sizeof(TypeInfo)/sizeof(TypesInfo[0]));
        TypesInfo[0].StructSize=sizeof(TypesInfo[0]);
        lstrcpy(TypesInfo[0].TypeString,"FarHelp");
        lstrcpy(TypesInfo[0].Mask,"*.hlf");
        TypesInfo[0].HFlags=F_NOKEYWORDSEARCH;
        data->TypesInfo=TypesInfo;
      }
      return TRUE;

    case AHMSG_SHOWHELP:
      {
        HelpInData *data = (HelpInData *)InData;
        Info.ShowHelp(data->FileName,data->Keyword,FHELP_CUSTOMFILE|FHELP_USECONTENTS);
        return TRUE; //FAR shows the error by itself.
      }
  }
  return FALSE;
}
