#include "ahp.hpp"
#include "crt.hpp"

int WINAPI _export Start(const struct PluginStartupInfo *FarInfo,const struct AHPluginStartupInfo *AHInfo)
{
  (void *)FarInfo;
  (void *)AHInfo;
  return 0;
}

void WINAPI _export Exit(void)
{
}

int WINAPI _export Message(unsigned long Msg,void *InData,void *OutData)
{
  switch(Msg)
  {
    case AHMSG_GETINFO:
      {
        GetInfoOutData *data=(GetInfoOutData *)OutData;
        data->TypesNumber=1;
        static struct TypeInfo TypesInfo[1];
        memset(TypesInfo,0,sizeof(TypeInfo)/sizeof(TypesInfo[0]));
        TypesInfo[0].StructSize=sizeof(TypesInfo[0]);
        lstrcpy(TypesInfo[0].TypeString,"WinHelp");
        lstrcpy(TypesInfo[0].Mask,"*.hlp");
        lstrcpy(TypesInfo[0].Encoding,"WIN");
        data->TypesInfo=TypesInfo;
      }
      return TRUE;

    case AHMSG_SHOWHELP:
      {
        HelpInData *data = (HelpInData *)InData;
        UINT uiCommand;
        DWORD dwData;
        if (*data->Keyword)
        {
          uiCommand = HELP_KEY;
          dwData = (DWORD)data->Keyword;
        }
        else
        {
          uiCommand = HELP_FINDER;
          dwData = NULL;
        }
        int ret = WinHelp(GetDesktopWindow(),data->FileName,uiCommand,dwData);
        if (!ret)
        {
          HelpOutData *odata = (HelpOutData *)OutData;
          LPSTR MessageBuffer;
          DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_IGNORE_INSERTS|FORMAT_MESSAGE_FROM_SYSTEM;
          DWORD dwBufferLength = FormatMessageA(dwFormatFlags,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),(LPSTR)&MessageBuffer,0,NULL);
          lstrcpyn(odata->Error,MessageBuffer,dwBufferLength>128?128:dwBufferLength);
          CharToOem(odata->Error,odata->Error);
        }
        return ret;
      }
  }
  return FALSE;
}
